# COMPSCI 365
# Spring 2020
# YOUR NAME HERE
# Assignment 3: JPEG Manipulation

# Complete the relevant functions.
# Make sure to test your implementations.
# You can import any standard library.
# You can define any new function you want.

import tags

def carve_jpeg(inputFile):
    """
    Description: Read the input file and extract ANY/ALL valid
    # sequences of bytes that conform to the JPEG standard.
    # The function should return a list of bytes objects, where each
    # bytes object is the extracted sequence of bytes corresponding
    # to one JPEG file. The ordering of the list does not matter. For
    # example, if l_1 = b'\xff\xd8\xff\xe0\x00\x10\x4a...', then
    # the list returned would be [l_1, l_2, ...]. If there is
    # just one valid JPEG file, then it would be [l_1]. If there are
    # no valid JPEG files, return an empty list.
    Input: string inputFile
    Output: list of bytes objects
    Example 1: carve_jpeg("main.py") = []
    Example 2: carve_jpeg("samples/sample1.jpg") = 
    # [b'\xff\xd8\xff\xe0...\xff\xd9', b'\xff\xd8\xff...\xff\xd9']
    """
    pass

def parse_exif(inputBytes):
    """
    Description: Given a sequence of bytes inputBytes that is
    # interpreted as a JPEG file, parse through the bytes to find
    # ANY/ALL EXIF segments. For each EXIF segment:
    # 1. Determine its endianness and handle data accordingly.
    # 2. For each IFD, determine the number of entries. Then,
    # for each entry in each IFD:
    #
    # 2.a. Extract the tag and value IF the tag is in tags.TAGS, AND
    ## IF the tag's format is in [1, 2, 3, 4, 5, 7].
    # 2.b. The tag and value should be stored in a tuple (TagName, Value),
    ## noting that if the value has multiple components then store them
    ## in a list (otherwise just as a single variable),
    ## where the value type corresponds for the following formats:
    ## Formats 1, 3, 4: int
    ## Formats 2, 5: str (for Format 5, use "x/y"; for Format 2, strip
    ## the trailing NULL byte)
    ## Format 7: bytes
    ## The tag names can be obtained from tags.TAGS.
    # 2.c. Add the tuple to a list that corresponds to the IFD.
    #
    # 3. Each list of extracted tuples should be stored as a value
    # in a dictionary, where the key is the offset of the IFD starting byte
    # (i.e. the first byte in the two bytes that specify the number of
    # entries that the IFD has) as an integer.
    # 4. Return this dictionary. If there are no entries in a given
    # IFD to extract, use an empty list in the dictionary. If there
    # are no IFDs, then return an empty dictionary.
    Input: bytes object
    Output: dictionary
    Example: parse_exif(carve_jpeg("samples/exif1.jpg")[0]) =
    # { 0x14: [ ("ImageDescription", " " * 31), ("Make", "NIKON"), ... ],
    # 0x1172: [ ("Compression", 6), ("XResolution", "72/1"), ("YResolution", "72/1"), ...],
    # ... }
    """
    pass
