# COMPSCI 365
# Spring 2020
# YOUR NAME HERE
# Assignment 3: WAV Manipulation

# Complete the relevant functions.
# Make sure to test your implementations.
# You can import any standard library.
# You can define any new function you want.

# WARNING: As you work through parsing
# the WAV standard, keep the endianness
# of each field in the file header in mind.

def carve_wav(inputFile):
    """
    Description: Read the input file and extract ANY/ALL valid
    # sequences of bytes that conform to the WAV standard. Assume
    # that all WAV file headers will only have three chunks: the
    # RIFF chunk, the fmt chunk (the basic style, not a variant),
    # and the data chunk. That is, the WAV file will be a
    # 44-byte header followed by the audio data. Also assume that
    # all WAV files will follow the WAVE PCM format category (0x0001).
    # The function should return a list of bytes objects, where each
    # bytes object is the extracted sequence of bytes corresponding
    # to one WAV file. The ordering of the list does not matter. For
    # example, if l_1 = b'\x52\x49\x46\x46\x71\xaf\x00\x00...', then
    # the list returned would be [l_1, l_2, ...]. If there is
    # just one valid WAV file, then it would be [l_1]. If there are
    # no valid WAV files, return an empty list.
    Input: string inputFile
    Output: list of bytes objects
    Example 1: carve_wav("main.py") = []
    Example 2: carve_wav("samples/sample1.jpg") = 
    # [bytes([82, 73, 70, 70, 240, 4, 2, 0, 87, 65, 86, ...])]
    """
    pass

def parse_wav_header(inputBytes):
    """
    Description: Given a sequence of bytes inputBytes that is
    # interpreted as a WAV file, parse the header and return
    # the extracted fields. These fields should be returned
    # in a dictionary, where each key is the field name, and
    # the corresponding value is the value found in the WAV
    # header. The values should be parsed according to the
    # WAV standard, and then stored in the dictionary
    # according to the format specified in wav_format.txt. If
    # a field is not included in wav_format.txt, then do not
    # include it in your returned dictionary.
    # If a field cannot be parsed properly, set the corresponding
    # dictionary value to None. If all fields cannot be parsed,
    # such as due to the bytes not being a valid sequence of
    # WAV bytes, or empty bytes object, return None.
    Input: bytes object
    Output: dictionary or None
    Example: parse_wav_header(carve_wav("samples/sample1.jpg")[0]) =
    # {'nChannels': 1, 'samplesPerSecond': 22050, ...}
    """
    pass
